文档章节

OpenCASCADE Make Primitives-Box

eryar
 eryar
发布于 2014/11/23 12:26
字数 2137
阅读 212
收藏 1

OpenCASCADE Make Primitives-Box

eryar@163.com

Abstract. By making a simple box to demonstrate the BRep data structure of the OpenCASCADE. The construction method is different from BRepPrimAPI_MakeBox. In the paper construct the box from vertex, edge to solid, while in BRepPrimAPI_MakeBox from solid, shell to vertex. From the construction, the BRep data structure in OpenCASCADE also can be called the Winged-Edge data structure.

Key Words. OpenCASCADE, BRep, Box, The Winged-Edge Structure

1. Introduction

OpenCASCADE的Toolit TKPrim中提供了基本图元的创建功能,像Box, Cylinder, Sphere等等。直接使用Package BRepPrimAPI中的功能,可以方便地创建出基本图元,而不用关心其内部的数据结构。

wps_clip_image-27189

Figure 1. BRepPrimAPI Package classes

为 了理解ModelingData模块中OpenCASCADE的边界表示法BRep数据结构,决定参考其实现,自己来创建出基本图元,进而理解其中的 BRep数据结构。本文以最简单的长方体Box入手,从点、边到体的创建出一个形状。并将构造的形状在Draw Test Harness中进行显示,且进行布尔运算,来验证构造结果的正确性。

2.Make a Face of the Box

在OpenCASCADE的包BRepPrim中,构造长方体的方式是形状的根结点出发到叶子结点,即从Shell到Face到Wire最后到Vertex,如下图所示:

wps_clip_image-5617

Figure 2.1 Data structure of a Shape

为了程序演示的清晰,本文中采用与OpenCASCADE中相反的方式,即先从叶子结点出发,逐步回到根结点,即先构造出顶点、边最后到实体。长方体由六个面构成,所以先从一个面开始来构造。将一个面构造成功后,其他六个面的构造方法就相同了。

构造使用了BRep_Builder,在创建相应的拓朴的同时可以将其相关的几何信息设置进去。如创建顶点Vertex时,可以将点的坐标信息及容差值设置进去,代码如下所示:

BRep_Builder aBuilder;

//  make vertex of the box.
aBuilder.MakeVertex(aVertices[ 0 ], aPoints[ 0 ], Precision::Confusion());
aBuilder.MakeVertex(aVertices[
1 ], aPoints[ 1 ], Precision::Confusion());
aBuilder.MakeVertex(aVertices[
2 ], aPoints[ 2 ], Precision::Confusion());
aBuilder.MakeVertex(aVertices[
3 ], aPoints[ 3 ], Precision::Confusion());
aBuilder.MakeVertex(aVertices[
4 ], aPoints[ 4 ], Precision::Confusion());
aBuilder.MakeVertex(aVertices[
5 ], aPoints[ 5 ], Precision::Confusion());
aBuilder.MakeVertex(aVertices[
6 ], aPoints[ 6 ], Precision::Confusion());
aBuilder.MakeVertex(aVertices[
7 ], aPoints[ 7 ], Precision::Confusion());

创建边的同时,将其边中的三维曲线信息也设置进去,代码如下所示:

//  make edges of the box.
aBuilder.MakeEdge(aEdges[ 0 ],  new  Geom_Line(aLines[ 0 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
1 ],  new  Geom_Line(aLines[ 1 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
2 ],  new  Geom_Line(aLines[ 2 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
3 ],  new  Geom_Line(aLines[ 3 ]), Precision::Confusion());

aBuilder.MakeEdge(aEdges[
4 ],  new  Geom_Line(aLines[ 4 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
5 ],  new  Geom_Line(aLines[ 5 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
6 ],  new  Geom_Line(aLines[ 6 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
7 ],  new  Geom_Line(aLines[ 7 ]), Precision::Confusion());

aBuilder.MakeEdge(aEdges[
8 ],  new  Geom_Line(aLines[ 8 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
9 ],  new  Geom_Line(aLines[ 9 ]), Precision::Confusion());
aBuilder.MakeEdge(aEdges[
10 ], new  Geom_Line(aLines[ 10 ]),Precision::Confusion());
aBuilder.MakeEdge(aEdges[
11 ], new  Geom_Line(aLines[ 11 ]),Precision::Confusion());

创建的边Edge还需要与顶点Vertex关联上,且需要注意顶点的反向,示例代码如下所示:

//  set the vertex info of the edges.
//  edge 0:
{
    TopoDS_Vertex V1 
=  aVertices[ 0 ];
    TopoDS_Vertex V2 
=  aVertices[ 1 ];

    V2.Reverse();

    aBuilder.Add(aEdges[
0 ], V1);
    aBuilder.Add(aEdges[
0 ], V2);

  aBuilder.UpdateVertex(V1, ElCLib::Parameter(aLines[
0 ], aPoints[ 0 ]), 
      aEdges[
0 ], Precision::Confusion());
  aBuilder.UpdateVertex(V2, ElCLib::Parameter(aLines[
0 ], aPoints[ 1 ]), 
      aEdges[
0 ], Precision::Confusion());

    BRepTools::Update(aEdges[
0 ]);
}

接着创建Wire,创建Wire时需要注意边的反向,从而构造成一个闭合的Wire,代码如下所示:

//  make wires of the box.
aBuilder.MakeWire(aWires[ 0 ]);

//  wire 1: bottom
{
    TopoDS_Edge E1 
=  aEdges[ 0 ];
    TopoDS_Edge E2 
=  aEdges[ 1 ];
    TopoDS_Edge E3 
=  aEdges[ 2 ];
    TopoDS_Edge E4 
=  aEdges[ 3 ];

    E3.Reverse();
    E4.Reverse();

    aBuilder.Add(aWires[
0 ], E1);
    aBuilder.Add(aWires[
0 ], E2);
    aBuilder.Add(aWires[
0 ], E3);
    aBuilder.Add(aWires[
0 ], E4);
    
    BRepTools::Update(aWires[
0 ]);
}

关键是面的创建及面创建后,设置边与面的关联信息,即PCurve的信息。如果没有PCurve的信息,可视化显示就不能正确显示出面,即网格化算法会失败。长方体底面的创建及PCurve设置代码如下所示:

//  make faces of the box.
aBuilder.MakeFace(aFaces[ 0 ], new  Geom_Plane(aPlanes[ 0 ]),Precision::Confusion());
aBuilder.Add(aFaces[
0 ], aWires[ 0 ]);
//  set bottom pcurve info of between the edge and surface.
{
    
//  pcurve 0:
     double  u  =   0.0 ;
    
double  v  =   0.0 ;
    
double  du  =   0.0 ;
    
double  dv  =   0.0 ;
    gp_Dir DX 
=  aPlanes[ 0 ].XAxis().Direction();
    gp_Dir DY 
=  aPlanes[ 0 ].YAxis().Direction();

    ElSLib::Parameters(aPlanes[
0 ], aLines[ 0 ].Location(), u, v);
    du 
=  aLines[ 0 ].Direction()  *  DX;
    dv 
=  aLines[ 0 ].Direction()  *  DY;

    aBuilder.UpdateEdge(aEdges[
0 ],  new  Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v), 
        gp_Dir2d(du, dv))), aFaces[
0 ], Precision::Confusion());
    
//  pcurve 1:
    ElSLib::Parameters(aPlanes[ 0 ], aLines[ 1 ].Location(), u, v);
    du 
=  aLines[ 1 ].Direction()  *  DX;
    dv 
=  aLines[ 1 ].Direction()  *  DY;

    aBuilder.UpdateEdge(aEdges[
1 ],  new  Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v), 
        gp_Dir2d(du, dv))), aFaces[
0 ], Precision::Confusion());
    
//  pcurve 2:
    ElSLib::Parameters(aPlanes[ 0 ], aLines[ 2 ].Location(), u, v);
    du 
=  aLines[ 2 ].Direction()  *  DX;
    dv 
=  aLines[ 2 ].Direction()  *  DY;

    aBuilder.UpdateEdge(aEdges[
2 ],  new  Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v), 
        gp_Dir2d(du, dv))), aFaces[
0 ], Precision::Confusion());
    
//  pcurve 3:
    ElSLib::Parameters(aPlanes[ 0 ], aLines[ 3 ].Location(), u, v);
    du 
=  aLines[ 3 ].Direction()  *  DX;
    dv 
=  aLines[ 3 ].Direction()  *  DY;

    aBuilder.UpdateEdge(aEdges[
3 ],  new  Geom2d_Line(gp_Lin2d(gp_Pnt2d(u, v), 
        gp_Dir2d(du, dv))), aFaces[
0 ], Precision::Confusion());
}

历经艰辛,最后终于将一个面创建出来了,且可以在Draw Test Harness中显示,如下图所示:

wps_clip_image-17990

Figure 2.2 A Face of the Box in Draw Test Harness

如上图所示,在Darw Test Harness中,边的颜色是有讲究的,说明如下:

In Draw Test Harness, shapes are displayed using isoparametric curves. There is color coding for the Edges:

v A red edge is an isolated edge, which belongs to no faces;

v A green edge is a free boundary edge, which belongs to one face;

v A yello edge is shared edge, which belongs to at least two faces;

wps_clip_image-27097

Figure 2.3 Color Coding for Edges in Draw Test Harness

如上图所示,红色的边表示此边不属于任何一个面;绿色的边表示此边只属于一个面;黄色的面表示此面至少属于两个面。

wps_clip_image-13274

Figure 2.4 Shared Edges of the Box

如上图所示,当创建出长方体的三个面时,侧面与上下两个底面相连的边显示成了黄色。其他边都是绿色。

3.Finish the Box

将长方体的六个面按上述方式创建完毕后,需要验证其正确性。于是将生成的数据导出为Brep格式,并与其他基本体进行布尔运算。

当导出的长方体为Shell时进行布尔运算会得到的也是壳体,如下图所示的结果:

wps_clip_image-88

Figure 3.1 Box Shell Cut a Cylinder

当导出的长方体为Solid时,若面的方式未正确设置,则布尔运算会失败,如下图所示:

wps_clip_image-331

Figure 3.2 Box Solid Cut a Cylinder

如上图所示,长方体与圆柱体的交线都已经计算出来了,但由于面的方向不对,不知道去除哪些面,保留哪些面。

将面的方向正确设置后,导出为Solid,进行布尔运算,结果正确,如下图所示:

wps_clip_image-22873

Figure 3.3 Box Cut Cylinder

测试用的Tcl脚本代码如下所示:

#
# Tcl script to test the box BRep data.
# eryar@163.com
# 2014-11-16 21:55
# OpenCASCADE6.8.0

pload ALL

restore d
:/ box . brep b

pcylinder c 
1.5   2

bop b c 
bopcut r

vdisplay r

4.Conclusion

通过创建基本图元,从而进一步来理解OpenCASCADE中的边界表示BRep的数据结构。需要注意的事项有:

v 创建边时,需要设置边中几何曲线的范围;

v 创建边时,需要设置正确与边相关顶点的方向;

v 创建环时,需要确保环中边的参数曲线PCurve能在参数空间中闭合;

v 创建面后,需要在边中设置与面相关的几何信息;

v 创建体时,需要所有面的方向正确;

注: 最后发现前不久写的一篇文章有误,说OpenCASCADE的BRep不是翼边结构。其实从边出发是可以找到与点、面相关的信息的。因为 OpenCASCADE中拓朴结构中有包含关系,所以顶点信息已经包含在边中了,直接遍历边即可得到与此边相关的顶点信息。所以,这样看来 OpenCASCADE中的BRep表示法也是翼边的数据结构。

原文如下:

边界表示方式比较。因为一般的书籍上都详细重 点描述了边界表示中以为边为核心的翼边数据结构,所以有人想从这方面来给OpenCASCADE中的Brep表示法来给个说法。结合上面的类图可知,从边 出发并不能访问到与这条边相关的其他信息,如顶点的信息。如果硬是想在这里给个名分,倒是从点出发可以找到边及面的几何信息,所以OpenCASCADE 中的Brep表示法应该更像是以点为基础的表示方法。OpenNURBS中通过ON_BrepTrim,可以访问其他的信息,而ON_BrepTrim与 边ON_BrepEdge的意义有些相似,所以应该是以边为核心的翼边结构了。

5. References

1. OpenCASCADE BRep vs. OpenNURBS Brep. OpenCASCADE BRep vs. OpenNURBS BRep

 

PDF Version and Source Code: OpenCASCADE Make Primitives-Box

© 著作权归作者所有

eryar
粉丝 21
博文 127
码字总数 227012
作品 0
武汉
私信 提问
FreeCAD 0.16 发布,开源 CAD/CAE 工具

FreeCAD 0.16 发布了,FreeCAD是一个基于OpenCASCADE的开源CAD/CAE工具。 OpenCASCADE是一套开源的CAD/CAM/CAE几何模型核心,来自法国Matra Datavision公司,是著名的CAD软件EUCLID的开发平台...

oschina
2016/04/21
2.9K
2
Building OpenCascade on Windows with Visual Studio

Building OpenCascade on Windows with Visual Studio eryar@163.com 摘要Abstract:详细说明OpenCascade的编译配置过程,希望对你编译OpenCascacde有所帮助。本文内容来自OCCT的Overview文档...

eryar
2013/09/23
0
0
如何将openCASCADE和c++结合起来,哪位牛人能不能给我指点指点啊.

如何将openCASCADE和c++结合起来,哪位牛人能不能给我指点指点啊.我现在正想用openCASCADE和c++结合起来做一个像cad软件的东西。

chenchenxixi
2012/07/09
1K
2
FreeCAD 0.17Pre 发布,开源 CAD/CAE 工具

FreeCAD 0.17Pre 发布了。 FreeCAD是一个基于OpenCASCADE的开源CAD/CAE工具。 OpenCASCADE是一套开源的CAD/CAM/CAE几何模型核心,来自法国Matra Datavision公司,是著名的CAD软件EUCLID的开发...

达尔文
2016/10/10
2.3K
3
FreeCAD 0.15.4671 发布,开源 CAD/CAE 工具

FreeCAD 0.15.4671 发布,此版本现已提供下载: FreeCAD-0.15.4671_x64_osx.zip (129.9 MB) freecad_0.15.4671.tar.gz freecad-0.15.4671-dfsg.tar.gz FreeCAD是一个基于OpenCASCADE的开源C......

oschina
2015/04/13
1K
3

没有更多内容

加载失败,请刷新页面

加载更多

面向对象方面的一些东东

<!DOCTYPE html> <html lang="zh"> <head> <meta charset="UTF-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <meta http-equiv="X-UA-Compatible" cont......

流年那么伤
31分钟前
2
0
git 过滤文件夹和文件(IDEA)

最近使用git版本管理工具遇到一件很烦的事情,commit时总会把.idea、.*.iml和target文件添加进来,实际开发中,这些是需要过滤掉的。在.gitnore文件添加了过滤不起作用。下面介绍一种成功过滤...

uug
39分钟前
2
0
Spark Streaming 实时统计商户当日累计PV流量

一、问题 对实时流量日志过滤筛选商户流量,对每个商户的流量进行累计,统计商户实时累计流量。 当时间超过24时时,重新统计当日商户的实时累计流量。 二、实现步骤 1、采用Spark Streaming...

boonya
44分钟前
2
0
如果Task与Event 创建了记录类型后,不出现在Lightning的Activities中

如果在Lightning的Activities没出现这两个Button,但是在页面布局的Lightning 按钮区也存在,全局操作的记录类型就需要选择一个,否则不会出现

在山的那边
52分钟前
2
0
ddd中的子域和界限上下文

我们先来说说子域是什么?子域在我的理解是在一个庞大的系统中可以明显感知的不同的区块,如果在电商模块中,商品目录,订单,物流,库存,发票等等都可以感知他们明显的不同,可以认为是子域...

算法之名
今天
3
0

没有更多内容

加载失败,请刷新页面

加载更多

返回顶部
顶部